#![allow(deprecated)]
use std::fmt;
use std::str;
/// A standard tileset to overlay on the base map.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum GeoAdditionalTileset {
    #[serde(rename = "VFR")]
    Vfr,
    #[serde(rename = "BATHYMETRY")]
    Bathymetry,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl GeoAdditionalTileset {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            GeoAdditionalTileset::Vfr => "VFR",
            GeoAdditionalTileset::Bathymetry => "BATHYMETRY",
            GeoAdditionalTileset::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for GeoAdditionalTileset {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for GeoAdditionalTileset {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for GeoAdditionalTileset {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<GeoAdditionalTileset, conjure_object::plain::ParseEnumError> {
        match v {
            "VFR" => Ok(GeoAdditionalTileset::Vfr),
            "BATHYMETRY" => Ok(GeoAdditionalTileset::Bathymetry),
            v => v.parse().map(|v| GeoAdditionalTileset::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for GeoAdditionalTileset {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<GeoAdditionalTileset, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the GeoAdditionalTileset enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
